# This file is part of phpVideoPro.
# 
# phpVideoPro is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# phpVideoPro is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with PerlPanel; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Copyright: (C) 2001-2004 Itzchak Rehberg <izzysoft@qumran.org>
#
# $Id$

Summary: A DVD/VCD/VideoTape cataloging software written in PHP.
Name: phpVideoPro
Version: 0.6.10
Release: 4
Epoch: 0
Group: Applications/Accessories
License: GPL
URL: http://www.qumran.org/homes/izzy/software/pvp/

Packager: Itzchak Rehberg <izzysoft@qumran.org>
Vendor: http://www.izzysoft.de/

Source: http://www.qumran.org/pub/net/div/izzysoft/%{name}/phpvideopro-%{version}.tar.gz
BuildRoot: %{_tmppath}/root-%{name}-%{version}
Prefix: /srv/www/htdocs/phpvideopro

AutoReq: no

%description
phpVideoPro is a program to manage your collection of DVDs, Video CDs, and
video tapes. It stores all data in a database, and provides you with features
for adding/changing entries, displaying lists, printing labels and lists, and
more. An online help system is built-in to guide you when necessary, and an
integrated user/session management protects your data against unauthorized
access. Support for multiple languages is provided, and supported databases
include MySQL and PostgreSQL.

#%prep
%setup

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/srv/www/htdocs
cp -rp ./ %{buildroot}/srv/www/htdocs
rm -f %{buildroot}/srv/www/htdocs/%{name}-%{version}/phpvideopro.spec

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,0755)
#/srv/www/htdocs/%{name}-%{version}/*
/srv/www/htdocs/*
